package com.sheep.gamegroup.dateview;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;
/**
 * Created by realicing on 2018/04/.
 * realicing@sina.com
 */
public class DateUtil {


    public static List<Integer> getDateForString(String date) {
        String[] dates = date.split("-");
        List<Integer> list = new ArrayList<>();
        list.add(Integer.parseInt(dates[0]));
        list.add(Integer.parseInt(dates[1]));
        list.add(Integer.parseInt(dates[2]));
        return list;
    }



    /**
     * 时间戳格式转换
     */
    private static String dayNames[] = {"周日", "周一", "周二", "周三", "周四", "周五", "周六"};

    public static String getTimeText(long millis) {
        return getTimeText(millis, "yy/MM/dd HH:mm", "yy/MM/dd HH:mm", false);
    }
    public static String getTimeText1(long millis) {
        return getTimeText(millis, "M月d日 %s HH:mm", "yyyy年M月d日 %s HH:mm", true);
    }
    public static String getTimeText(long millis,String timeF, String yearTimeF, boolean isShowAP) {
        millis = millis < 10_000_000_000L ? millis * 1000 : millis;//秒的时间戳为10位数,要x1000  10_000_000_000L对应时间为2286-11-21 01:46:40
        String result;
        Calendar todayCalendar = Calendar.getInstance();
        Calendar otherCalendar = Calendar.getInstance();
        otherCalendar.setTimeInMillis(millis);

        String timeFormat;
        String yearTimeFormat;
        String am_pm = "";
        if(isShowAP) {
            int hour = otherCalendar.get(Calendar.HOUR_OF_DAY);
            if (hour >= 0 && hour < 6) {
                am_pm = "凌晨";
            } else if (hour >= 6 && hour < 12) {
                am_pm = "早上";
            } else if (hour == 12) {
                am_pm = "中午";
            } else if (hour > 12 && hour < 18) {
                am_pm = "下午";
            } else if (hour >= 18) {
                am_pm = "晚上";
            }
        }
        timeFormat = isShowAP ? String.format(Locale.CHINA, timeF, am_pm) : timeF;//"M月d日 " + am_pm + "HH:mm";
        yearTimeFormat = isShowAP ? String.format(Locale.CHINA, yearTimeF, am_pm) : yearTimeF;//"yyyy年M月d日 " + am_pm + "HH:mm";

        boolean yearTemp = todayCalendar.get(Calendar.YEAR) == otherCalendar.get(Calendar.YEAR);
        if (yearTemp) {
            int todayMonth = todayCalendar.get(Calendar.MONTH);
            int otherMonth = otherCalendar.get(Calendar.MONTH);
            if (todayMonth == otherMonth) {//表示是同一个月
                int temp = todayCalendar.get(Calendar.DATE) - otherCalendar.get(Calendar.DATE);
                switch (temp) {
                    case 0:
                        result = am_pm+getHourAndMin(millis);
                        break;
                    case 1:
                        result = "昨天 " +am_pm+ getHourAndMin(millis);
                        break;
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                        int dayOfMonth = otherCalendar.get(Calendar.WEEK_OF_MONTH);
                        int todayOfMonth = todayCalendar.get(Calendar.WEEK_OF_MONTH);
                        if (dayOfMonth == todayOfMonth) {//表示是同一周
                            int dayOfWeek = otherCalendar.get(Calendar.DAY_OF_WEEK);
                            if (dayOfWeek != 1) {//判断当前是不是星期日     如想显示为：周日 12:09 可去掉此判断
                                result = dayNames[otherCalendar.get(Calendar.DAY_OF_WEEK) - 1]+am_pm + getHourAndMin(millis);
                            } else {
                                result = getTime(millis, timeFormat);
                            }
                        } else {
                            result = getTime(millis, timeFormat);
                        }
                        break;
                    default:
                        result = getTime(millis, timeFormat);
                        break;
                }
            } else {
                result = getTime(millis, timeFormat);
            }
        } else {
            result = getYearTime(millis, yearTimeFormat);
        }
        return result;
    }

    /**
     * 当天的显示时间格式
     */
    public static String getHourAndMin(long time) {
        SimpleDateFormat format = new SimpleDateFormat("HH:mm", Locale.CHINA);
        return format.format(new Date(time));
    }

    /**
     * 不同一周的显示时间格式
     */
    public static String getTime(long time, String timeFormat) {
        SimpleDateFormat format = new SimpleDateFormat(timeFormat, Locale.CHINA);
        return format.format(new Date(time));
    }

    /**
     * 不同年的显示时间格式
     */
    public static String getYearTime(long time, String yearTimeFormat) {
        SimpleDateFormat format = new SimpleDateFormat(yearTimeFormat, Locale.CHINA);
        return format.format(new Date(time));
    }

}
